osgGA::DriveManipulator Class Reference

`#include <DriveManipulator>`

Inheritance diagram for osgGA::DriveManipulator:

## Public Member Functions

| DriveManipulator ()
virtual const char * | className () const
virtual void | setByMatrix (const osg::Matrixd &matrix)
virtual void | setByInverseMatrix (const osg::Matrixd &matrix)
virtual osg::Matrixd | getMatrix () const
virtual osg::Matrixd | getInverseMatrix () const
virtual void | setNode (osg::Node *)
virtual const osg::Node * | getNode () const
virtual osg::Node * | getNode ()
virtual void | computeHomePosition ()
virtual void | home (const GUIEventAdapter &ea, GUIActionAdapter &us)
virtual void | init (const GUIEventAdapter &ea, GUIActionAdapter &us)
virtual bool | handle (const GUIEventAdapter &ea, GUIActionAdapter &us)
virtual void | getUsage (osg::ApplicationUsage &usage) const
void | setModelScale (double in_ms)
double | getModelScale () const
void | setVelocity (double in_vel)
double | getVelocity () const
void | setHeight (double in_h)
double | getHeight () const
Public Member Functions inherited from osgGA::CameraManipulator
virtual void | setCoordinateFrameCallback (CoordinateFrameCallback *cb)
CoordinateFrameCallback * | getCoordinateFrameCallback ()
const CoordinateFrameCallback * | getCoordinateFrameCallback () const
osg::CoordinateFrame | getCoordinateFrame (const osg::Vec3d &position) const
osg::Vec3d | getSideVector (const osg::CoordinateFrame &cf) const
osg::Vec3d | getFrontVector (const osg::CoordinateFrame &cf) const
osg::Vec3d | getUpVector (const osg::CoordinateFrame &cf) const
virtual void | updateCamera (osg::Camera &camera)
virtual osgUtil::SceneView::FusionDistanceMode | getFusionDistanceMode () const
virtual float | getFusionDistanceValue () const
void | setIntersectTraversalMask (unsigned int mask)
unsigned int | getIntersectTraversalMask () const
virtual void | setHomePosition (const osg::Vec3d &eye, const osg::Vec3d &center, const osg::Vec3d &up, bool autoComputeHomePosition=false)
virtual void | getHomePosition (osg::Vec3d &eye, osg::Vec3d &center, osg::Vec3d &up) const
virtual void | setAutoComputeHomePosition (bool flag)
bool | getAutoComputeHomePosition () const
virtual void | computeHomePosition (const osg::Camera *camera=NULL, bool useBoundingBox=false)
virtual void | finishAnimation ()
virtual void | home (double)
virtual bool | handle (osgGA::Event *event, osg::Object *object, osg::NodeVisitor *nv)
Public Member Functions inherited from osgGA::GUIEventHandler
| GUIEventHandler ()
| GUIEventHandler (const GUIEventHandler &eh, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
| META_Object (osgGA, GUIEventHandler)
virtual bool | handle (const GUIEventAdapter &ea, GUIActionAdapter &aa, osg::Object *, osg::NodeVisitor *)
Public Member Functions inherited from osgGA::EventHandler
| EventHandler ()
| EventHandler (const EventHandler &eh, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
| META_Object (osgGA, EventHandler)
virtual NodeCallback * | asNodeCallback ()
virtual const NodeCallback * | asNodeCallback () const
virtual DrawableEventCallback * | asDrawableEventCallback ()
virtual const DrawableEventCallback * | asDrawableEventCallback () const
virtual EventHandler * | asEventHandler ()
virtual const EventHandler * | asEventHandler () const
virtual bool | run (osg::Object *object, osg::Object *data)
virtual void | operator() (osg::Node *node, osg::NodeVisitor *nv)
virtual void | event (osg::NodeVisitor *nv, osg::Drawable *drawable)
Public Member Functions inherited from osg::NodeCallback
| NodeCallback ()
| NodeCallback (const NodeCallback &nc, const CopyOp &copyop)
| META_Object (osg, NodeCallback)
Public Member Functions inherited from osg::Callback
| Callback ()
| Callback (const Callback &cb, const CopyOp &copyop)
| META_Object (osg, Callback)
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual StateAttributeCallback * | asStateAttributeCallback ()
virtual const StateAttributeCallback * | asStateAttributeCallback () const
virtual UniformCallback * | asUniformCallback ()
virtual const UniformCallback * | asUniformCallback () const
virtual DrawableUpdateCallback * | asDrawableUpdateCallback ()
virtual const DrawableUpdateCallback * | asDrawableUpdateCallback () const
virtual DrawableCullCallback * | asDrawableCullCallback ()
virtual const DrawableCullCallback * | asDrawableCullCallback () const
bool | traverse (osg::Object *object, osg::Object *data)
void | setNestedCallback (osg::Callback *cb)
osg::Callback * | getNestedCallback ()
const osg::Callback * | getNestedCallback () const
void | addNestedCallback (osg::Callback *nc)
void | removeNestedCallback (osg::Callback *nc)
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const =0
virtual Object * | clone (const CopyOp &) const =0
virtual bool | isSameKindAs (const Object *) const
virtual const char * | libraryName () const =0
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
virtual void | resizeGLObjectBuffers (unsigned int)
virtual void | releaseGLObjects (osg::State *=0) const
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const
Public Member Functions inherited from osg::DrawableEventCallback
| DrawableEventCallback ()
| DrawableEventCallback (const DrawableEventCallback &org, const CopyOp &copyop)
| META_Object (osg, DrawableEventCallback)

## Protected Types

enum | SpeedControlMode { USE_MOUSE_Y_FOR_SPEED , USE_MOUSE_BUTTONS_FOR_SPEED }

## Protected Member Functions

virtual | ~DriveManipulator ()
bool | intersect (const osg::Vec3d &start, const osg::Vec3d &end, osg::Vec3d &intersection, osg::Vec3d &normal) const
void | flushMouseEventStack ()
void | addMouseEvent (const GUIEventAdapter &ea)
void | computePosition (const osg::Vec3d &eye, const osg::Vec3d &lv, const osg::Vec3d &up)
bool | calcMovement ()
Protected Member Functions inherited from osgGA::CameraManipulator
| CameraManipulator ()
| CameraManipulator (const CameraManipulator &mm, const osg::CopyOp &copyOp=osg::CopyOp::SHALLOW_COPY)
virtual | ~CameraManipulator ()
std::string | getManipulatorName () const
Protected Member Functions inherited from osgGA::GUIEventHandler
virtual | ~GUIEventHandler ()
Protected Member Functions inherited from osg::NodeCallback
virtual | ~NodeCallback ()
Protected Member Functions inherited from osg::Callback
virtual | ~Callback ()
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

osg::ref_ptr< const GUIEventAdapter > | _ga_t1
osg::ref_ptr< const GUIEventAdapter > | _ga_t0
osg::observer_ptr< osg::Node > | _node
double | _modelScale
double | _velocity
double | _height
double | _buffer
SpeedControlMode | _speedMode
osg::Vec3d | _eye
osg::Quat | _rotation
double | _pitch
double | _distance
bool | _pitchUpKeyPressed
bool | _pitchDownKeyPressed
Protected Attributes inherited from osgGA::CameraManipulator
unsigned int | _intersectTraversalMask
bool | _autoComputeHomePosition
osg::Vec3d | _homeEye
osg::Vec3d | _homeCenter
osg::Vec3d | _homeUp
osg::ref_ptr< CoordinateFrameCallback > | _coordinateFrameCallback
Protected Attributes inherited from osg::Callback
ref_ptr< Callback > | _nestedCallback
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }
Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Detailed Description

DriveManipulator is a camera manipulator which provides drive-like functionality. By default, the left mouse button accelerates, the right mouse button decelerates, and the middle mouse button (or left and right simultaneously) stops dead.

## Member Enumeration Documentation

## SpeedControlMode

enum osgGA::DriveManipulator::SpeedControlMode

protected

Enumerator
USE_MOUSE_Y_FOR_SPEED |
USE_MOUSE_BUTTONS_FOR_SPEED |

## Constructor & Destructor Documentation

## DriveManipulator()

osgGA::DriveManipulator::DriveManipulator | ( |  | ) |

## ~DriveManipulator()

virtual osgGA::DriveManipulator::~DriveManipulator | ( |  | ) |

protected virtual

## Member Function Documentation

## addMouseEvent()

void osgGA::DriveManipulator::addMouseEvent | ( | const GUIEventAdapter & | ea | ) |

protected

Add the current mouse GUIEvent to internal stack.

## calcMovement()

bool osgGA::DriveManipulator::calcMovement | ( |  | ) |

protected

For the given mouse movement calculate the movement of the camera. Return true if camera has moved and a redraw is required.

## className()

virtual const char * osgGA::DriveManipulator::className | ( |  | ) | const

inline virtual

return the name of the object's class type. Must be defined by derived classes.

Reimplemented from osgGA::CameraManipulator.

## computeHomePosition()

virtual void osgGA::DriveManipulator::computeHomePosition | ( |  | ) |

virtual

## computePosition()

void osgGA::DriveManipulator::computePosition | ( | const osg::Vec3d & | eye,
|  | const osg::Vec3d & | lv,
|  | const osg::Vec3d & | up )

protected

## flushMouseEventStack()

void osgGA::DriveManipulator::flushMouseEventStack | ( |  | ) |

protected

Reset the internal GUIEvent stack.

## getHeight()

double osgGA::DriveManipulator::getHeight | ( |  | ) | const

inline

References _height.

## getInverseMatrix()

virtual osg::Matrixd osgGA::DriveManipulator::getInverseMatrix | ( |  | ) | const

virtual

Get the position of the manipulator as a inverse matrix of the manipulator, typically used as a model view matrix.

Implements osgGA::CameraManipulator.

## getMatrix()

virtual osg::Matrixd osgGA::DriveManipulator::getMatrix | ( |  | ) | const

virtual

Get the position of the manipulator as 4x4 Matrix.

Implements osgGA::CameraManipulator.

## getModelScale()

double osgGA::DriveManipulator::getModelScale | ( |  | ) | const

inline

References _modelScale.

## getNode() [1/2]

virtual osg::Node * osgGA::DriveManipulator::getNode | ( |  | ) |

virtual

Return node if attached.

Reimplemented from osgGA::CameraManipulator.

## getNode() [2/2]

virtual const osg::Node * osgGA::DriveManipulator::getNode | ( |  | ) | const

virtual

Return const node if attached.

Reimplemented from osgGA::CameraManipulator.

## getUsage()

virtual void osgGA::DriveManipulator::getUsage | ( | osg::ApplicationUsage & | usage | ) | const

virtual

Get the keyboard and mouse usage of this manipulator.

Reimplemented from osgGA::EventHandler.

## getVelocity()

double osgGA::DriveManipulator::getVelocity | ( |  | ) | const

inline

References _velocity.

## handle()

virtual bool osgGA::DriveManipulator::handle | ( | const GUIEventAdapter & | ea,
|  | GUIActionAdapter & | us )

virtual

Handle events, return true if handled, false otherwise.

Reimplemented from osgGA::CameraManipulator.

## home()

virtual void osgGA::DriveManipulator::home | ( | const GUIEventAdapter & | ,
|  | GUIActionAdapter & | )

virtual

Move the camera to the default position. May be ignored by manipulators if home functionality is not appropriate.

Reimplemented from osgGA::CameraManipulator.

## init()

virtual void osgGA::DriveManipulator::init | ( | const GUIEventAdapter & | ,
|  | GUIActionAdapter & | )

virtual

Start/restart the manipulator.

Reimplemented from osgGA::CameraManipulator.

## intersect()

bool osgGA::DriveManipulator::intersect | ( | const osg::Vec3d & | start,
|  | const osg::Vec3d & | end,
|  | osg::Vec3d & | intersection,
|  | osg::Vec3d & | normal ) const

protected

## setByInverseMatrix()

virtual void osgGA::DriveManipulator::setByInverseMatrix | ( | const osg::Matrixd & | matrix | ) |

inline virtual

Set the position of the matrix manipulator using a 4x4 Matrix.

Implements osgGA::CameraManipulator.

References osg::Matrixd::inverse(), and setByMatrix().

## setByMatrix()

virtual void osgGA::DriveManipulator::setByMatrix | ( | const osg::Matrixd & | matrix | ) |

virtual

Get the position of the matrix manipulator using a 4x4 Matrix.

Implements osgGA::CameraManipulator.

Referenced by setByInverseMatrix().

## setHeight()

void osgGA::DriveManipulator::setHeight | ( | double | in_h | ) |

inline

References _height.

## setModelScale()

void osgGA::DriveManipulator::setModelScale | ( | double | in_ms | ) |

inline

References _modelScale.

## setNode()

virtual void osgGA::DriveManipulator::setNode | ( | osg::Node * |  | ) |

virtual

Attach a node to the manipulator, automatically detaching any previously attached node. setNode(NULL) detaches previous nodes. May be ignored by manipulators which do not require a reference model.

Reimplemented from osgGA::CameraManipulator.

## setVelocity()

void osgGA::DriveManipulator::setVelocity | ( | double | in_vel | ) |

inline

References _velocity.

## Member Data Documentation

## _buffer

double osgGA::DriveManipulator::_buffer

protected

## _distance

double osgGA::DriveManipulator::_distance

protected

## _eye

osg::Vec3d osgGA::DriveManipulator::_eye

protected

## _ga_t0

osg::ref_ptr<const GUIEventAdapter> osgGA::DriveManipulator::_ga_t0

protected

## _ga_t1

osg::ref_ptr<const GUIEventAdapter> osgGA::DriveManipulator::_ga_t1

protected

## _height

double osgGA::DriveManipulator::_height

protected

Referenced by getHeight(), and setHeight().

## _modelScale

double osgGA::DriveManipulator::_modelScale

protected

Referenced by getModelScale(), and setModelScale().

## _node

osg::observer_ptr<osg::Node> osgGA::DriveManipulator::_node

protected

## _pitch

double osgGA::DriveManipulator::_pitch

protected

## _pitchDownKeyPressed

bool osgGA::DriveManipulator::_pitchDownKeyPressed

protected

## _pitchUpKeyPressed

bool osgGA::DriveManipulator::_pitchUpKeyPressed

protected

## _rotation

osg::Quat osgGA::DriveManipulator::_rotation

protected

## _speedMode

SpeedControlMode osgGA::DriveManipulator::_speedMode

protected

## _velocity

double osgGA::DriveManipulator::_velocity

protected

Referenced by getVelocity(), and setVelocity().

The documentation for this class was generated from the following file:

- DriveManipulator